/*
 * FieldValue.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <assert.h>
#include "stdafx.h"

#include "FieldValue.h"
#include "Scene.h"
#include "Element.h"

FieldValue::FieldValue() {
    _refs = 0;
}

FieldValue::FieldValue(const FieldValue &)
{
    _refs = 0;
}

void
FieldValue::write(FILE *f, int indent) const
{
    indentf(f, indent);
    fprintf(f, "# UNKNOWN VALUE\n");
}

FieldValue *
FieldValue::addNode(Node * /* node */) const
{
    assert(0);
    return NULL;
}

FieldValue *
FieldValue::removeNode(Node * /* node */) const
{
    assert(0);
    return NULL;
}

void
indentf(FILE *f, int indent)
{
    int		tabs = indent / 8;
    int		spaces = indent % 8;
    char       *buf = new char[tabs + spaces + 1];
    char       *b = buf;

    for(int i = 0; i < tabs; i++)
	*b++ = '\t';

    for(int j = 0; j < spaces; j++)
	*b++ = ' ';

    *b = '\0';
    fprintf(f, buf);
    delete[] buf;
}
