/*
 * Image.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <assert.h>
#include "stdafx.h"
#include "Image.h"
#include "gif.h"
#include "jpegLoad.h"

Image::Image()
{
}

Image::~Image()
{
}

bool
Image::Open(const char *filename)
{
    if (gifOpen(filename, &_width, &_height)) {
	_type = GIF;
	_components = 3;
	return true;
    } else if (jpegOpen(filename, &_width, &_height, &_components)) {
	_type = JPEG;
	return true;
    } else {
	return false;
    }
}

void
Image::Read(unsigned char *data)
{
    switch (_type) {
    case GIF:
	gifRead(data);
	break;
    case JPEG:
	jpegRead(data);
	break;
    default:
	assert(false);
    }
}
