/*
 * MFInt32.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "MFInt32.h"
#include "SFInt32.h"

MFInt32::MFInt32()
{
}

MFInt32::MFInt32(const int *values, int len)
{
    _value.resize(len);
    for (int i = 0; i < len; i++) {
	_value[i] = values[i];
    }
}

MFInt32::MFInt32(const MFInt32 &value)
  : _value(value._value)
{
}

void MFInt32::write(FILE *f, int indent) const
{
    fprintf(f, "[\n");
    for (int i = 0; i < _value.size(); i++) {
	indentf(f, indent);
	fprintf(f, "%d\n", _value[i]);
    }
    indentf(f, indent);
    fprintf(f, "]\n");
}

bool
MFInt32::equals(const FieldValue *value) const
{
    if (value->getType() == MFINT32) {
	MFInt32		*v = (MFInt32 *) value;
	if (v->getSize() != _value.size()) return false;
	for (int i = 0; i < _value.size(); i++)
	    if (_value[i] != v->getValue(i))
		return false;
	return true;
    }
    return false;
}

FieldValue *
MFInt32::getSFValue(int index) const
{
    return new SFInt32(_value[index]);
}

void
MFInt32::setSFValue(int index, FieldValue *value)
{
    _value[index] = ((SFInt32 *) value)->getValue();
}

