/*
 * MFRotation.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h> 
#include "stdafx.h"

#include "MFRotation.h"
#include "SFRotation.h"

MFRotation::MFRotation() : MFFloat()
{
}

MFRotation::MFRotation(const float values[], int len) : MFFloat(values, len)
{
}

bool
MFRotation::equals(const FieldValue *value) const
{
    return value->getType() == MFROTATION && MFFloat::equals((const MFFloat *) value);
}

FieldValue *
MFRotation::getSFValue(int index) const
{
    return new SFRotation(getValue(index));
}

void
MFRotation::setSFValue(int index, FieldValue *value)
{
    SFRotation	*v = (SFRotation *) value;

    const float	*values = v->getValue();

    _value[index*4] = values[0];
    _value[index*4+1] = values[1];
    _value[index*4+2] = values[2];
    _value[index*4+3] = values[3];
}

