/*
 * MFString.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "MFString.h"
#include "SFString.h"

MFString::MFString()
{
    _value = new StringArray();
}

MFString::MFString(StringArray *values)
{
    _value = values;
}

MFString::MFString(String value)
{
    _value =  new StringArray();
    _value->append(value);
}

MFString::MFString(const MFString &string)
{
    _value = new StringArray(*string._value);
}

MFString::~MFString()
{
    delete _value;
}

void MFString::write(FILE *f, int indent) const
{
    fprintf(f, "[\n");
    for (int i = 0; i < _value->size(); i++) {
	indentf(f, indent+2);
	fprintf(f, "\"");
	const char	*s = (const char *) _value->get(i);
	fputs(s, f);
	fprintf(f, "\"\n");
    }
    indentf(f, indent);
    fprintf(f, "]\n");
}

bool
MFString::equals(const FieldValue *value) const
{
    if (value->getType() == MFSTRING) {
	MFString	*v = (MFString *) value;
	if (v->getSize() != _value->size()) return false;
	for (int i = 0; i < _value->size(); i++)
	    if (v->getValue(i) != _value->get(i)) return false;
	return true;
    }
    return false;
}

FieldValue *
MFString::getSFValue(int index) const
{
    return new SFString(_value->get(index)); 
}

void
MFString::setSFValue(int index, FieldValue *value)
{
    _value->set(index, ((SFString *) value)->getValue());
}

