/*
 * NodeNavigationInfo.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "NodeNavigationInfo.h"
#include "Scene.h"
#include "Proto.h"
#include "FieldValue.h"
#include "MFFloat.h"
#include "SFBool.h"
#include "SFFloat.h"
#include "MFString.h"
#include "SFString.h"
#include "Node.h"


ProtoNavigationInfo::ProtoNavigationInfo(Scene *scene)
  : Proto(scene, "NavigationInfo")
{
    addEventIn(SFBOOL, "set_bind");
    float		values[] = { 0.25f, 1.6f, 0.75f };
    addExposedField(MFFLOAT, "avatarSize", new MFFloat(values, 3), 0.0f);
    addExposedField(SFBOOL, "headlight", new SFBool(true));
    addExposedField(SFFLOAT, "speed", new SFFloat(1.0f), 0.0f);

    // FIXME:  change default value to [ "WALK", "ANY" ]
    addExposedField(MFSTRING, "type", new MFString());
    addExposedField(SFFLOAT, "visibilityLimit", new SFFloat(0.0f), 0.0f);
    addEventOut(SFBOOL, "isBound");
}

NodeNavigationInfo::NodeNavigationInfo(Scene *scene, Proto *def)
  : Node(scene, def)
{
}

void
NodeNavigationInfo::preDraw()
{
//    const float *avatarSize = ((MFFloat *) getField(0))->getValue();
    int headlight = ((SFBool *) getField(1))->getValue();
//    float speed = ((SFFloat *) getField(2))->getValue();
//    const char *type = ((SFString *) getField(3))->getValue();
//    float visiblityLimit = ((SFFloat *) getField(4))->getValue();

    _scene->setHeadlight(headlight);
}
