/*
 * SFImage.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>
#include "stdafx.h"

#include "SFImage.h"

SFImage::SFImage(int width, int height, int depth, const int *pixels)
{
    _width = width;
    _height = height;
    _depth = depth;
    _pixels.resize(width * height);
    for (int i = 0; i < width * height; i++)
	_pixels[i] = pixels[i];
}

void SFImage::write(FILE *f, int indent) const
{
    fprintf(f, "%d %d %d\n", _width, _height, _depth);
    for (int i = 0; i < _width * _height; i++) {
	indentf(f, indent+2);
	fprintf(f, "0x%08x\n", _pixels[i]);
    }
}

bool
SFImage::equals(const FieldValue *value) const
{
    if (value->getType() == SFIMAGE) {
	SFImage		*v = (SFImage *) value;

	return v->getWidth() == _width
	    && v->getHeight() == _height
	    && v->getDepth() == _depth
	    && !memcmp(v->getPixels(), _pixels.getData(), _width * _height);
    }
    return false;
}
