/*
 * SFString.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "SFString.h"

SFString::SFString(const String &value)
  : _value(value)
{
}

SFString::SFString(const char *str)
  : _value(str)
{  
}

bool
SFString::equals(const FieldValue *value) const
{
    return value->getType() == SFSTRING &&
      !strcmp(((SFString *) value)->getValue(), (const char *) _value);
}

void SFString::write(FILE *f, int /* indent */) const
{
    fprintf(f, "\"%s\"\n", (const char *) _value);
}
