/*
 * SFVec2f.cpp
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "SFVec2f.h"

SFVec2f::SFVec2f(float x, float y)
{
    _value[0] = x; _value[1] = y;
}

SFVec2f::SFVec2f(const float *values)
{
    _value[0] = values[0]; _value[1] = values[1];
}

bool
SFVec2f::equals(const FieldValue *value) const
{
    return value->getType() == SFVEC2F
	&& ((SFVec2f *) value)->getValue(0) == _value[0]
	&& ((SFVec2f *) value)->getValue(1) == _value[1];
}

void SFVec2f::write(FILE *f, int /* indent */) const
{
    fprintf(f, "%g %g\n", _value[0], _value[1]);
}
