/*
 * SceneView.h
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#ifndef _SCENE_VIEW_H
#define _SCENE_VIEW_H

class Hint;
class Scene;
typedef struct SWindow *SWND;

class SceneView {
public:
    			SceneView(Scene *scene, SWND parent);
    virtual 	       ~SceneView();

    Scene              *GetScene() const { return _scene; }
    void		SetScene(Scene *scene)	{ _scene = scene; }
    SWND		GetWindow() const { return _wnd; }

    virtual void	OnDraw(int x, int y, int width, int height) {}
    virtual void	OnSize(int width, int height) {}
    virtual void	OnMouseEnter() {}
    virtual void	OnMouseLeave() {}
    virtual void	OnKeyDown(int key, int x, int y, int modifiers) {}
    virtual void	OnKeyUp(int key, int x, int y, int modifiers) {}
    virtual void	OnLButtonDown(int x, int y, int modifiers) {}
    virtual void	OnLButtonUp(int x, int y, int modifiers) {}
    virtual void	OnMouseMove(int x, int y, int modifiers) {}
    virtual void	OnCommand(int id) {}
    virtual int		OnDragEnter(int x, int y, int modifiers) { return 0; }
    virtual int		OnDragOver(int x, int y, int modifiers) { return 0; }
    virtual void	OnDragLeave() {}
    virtual int		OnDrop(int x, int y, int modifiers) { return 0; }
    virtual void	OnUpdate(SceneView *sender, int type, Hint *hint) {}

    void		RegisterDropTarget();
    void		UnregisterDropTarget();

protected:
    Scene	       *_scene;
    SWND		_wnd;
};

#endif // _SCENE_VIEW_H
